'*******************************************************************************
'*        DS18B20                *
'*        RTC-433                            *
'*            *
'*   24   ,  1-                           *
'*  Date    : 02.12.11                                      *
'*  Version : 1.0                                               *
'*  Notes   :  CR2032                                    *
'*          :                                                   *
'****************************************************************
Device 12F629
 
Config INTRC_OSC_NOCLKOUT, MCLRE_OFF, PWRTE_OFF, WDT_ON, BODEN_OFF, CP_OFF ' INTRC_OSC_NOCLKOUT
Xtal 4

'OPTION_REG = %10001111  ;   0  INT
'INTCON     = %10010000
OSCCAL     = %10000000
CMCON      = %00000111


Set_OSCCAL OSCCAL      '     OSCCA

TRISIO = %10000

Dim peredacha               As Byte
Dim nomer_bita              As Byte
Dim codr                    As Byte
Dim time                    As Byte
Dim schet                   As Byte
Dim serial                  As Word
Dim znak                    As Byte
Dim Temperatura             As Byte
Dim nomer_byta              As Byte
Dim CRC                     As Word
Dim pitanie_peredat         As GPIO.0
Dim vhod_peredat            As GPIO.1
Dim DQ                      As GPIO.5 '   ds18b20
Dim nol                     As 600
Dim odin                    As 1200
Dim i                       As Byte
Dim dan[24]                 As Byte
Dim wkl                     As Byte


    Dim Temp_read   As  Word
    Dim Sign        As  Byte
    Dim TempC       As  Byte
    Dim TemperC     As  Word 
    Dim Float0      As  Byte
    Dim Float1      As  Byte
    Dim command     As  Byte   
Clear 


pitanie_peredat = 0
vhod_peredat = 0
wkl=0
DelayMS 100


serial = 2487'   
'        

dan[0]=serial.HighByte
dan[1]=serial.LowByte'c      .

;-----------------------------------------------------------
;---------------------  ------------------------------
;-----------------------------------------------------------

main:
   pitanie_peredat = 1 '  
       


        GoSub init1820          ' Init the DS1820
        command = $cc           ' Issue Skip ROM command
        GoSub write1820
        command = $44           ' Start temperature conversion
        GoSub write1820
        GoSub init1820            ' Do another init
        command = $cc             ' Issue Skip ROM command
        GoSub write1820
        command = $be             ' Read the temperature
        GoSub write1820
        GoSub read1820
        GoSub Temp_calc
                
        dan[2]=TempC
        dan[3]=Sign
        
        
        CRC=0
        For i=0 To 21  '    
        CRC=crc+dan[i]
        Next
        
        
        dan[22]=CRC.HighByte '     2 
        dan[23]=CRC.LowByte
        
         DelayMS 1
         
    For nomer_bita = 0 To 7 '    
        vhod_peredat = 1
        DelayUS nol
        vhod_peredat = 0
        DelayUS nol
        Clrwdt
    Next
   
   
    DelayMS 2 '  2-0  10-1
    vhod_peredat = 1 ' 10-1
    DelayMS 10
    vhod_peredat = 0
    Clrwdt
    GoSub peredacha_bytov    ;    
    
    
    DelayMS 250
    vhod_peredat = 0          '  
    DelayMS 250
    pitanie_peredat = 0 '  
 

 If wkl=0 Then metka

'-------------------------  -----------------------------
GPIO = 0
Sleep 1          ;    1   - 60 
Nop
INTCON.1 = 0
'---------------------------------------------------------

metka:
wkl=1
GoTo main




;-----------------------------------------------------------
;----------    ----------------
;-----------------------------------------------------------
peredacha_bytov:
DelayUS nol
For nomer_byta = 0 To 23 ' 24  
    DelayUS odin
    peredacha=dan[nomer_byta]

    For nomer_bita = 0 To 7
        If GetBit peredacha,nomer_bita = 1 Then
        vhod_peredat = 1
        DelayUS odin
        vhod_peredat = 0
        DelayUS nol
        Else
        vhod_peredat = 1
        DelayUS nol
        vhod_peredat = 0
        DelayUS nol
        EndIf
        Clrwdt
    Next
Next
Return
'=========================================================================================




    Temp_calc:					' 
'******************************************************************************************************
    If Temp_read.11 = 1 Then  '   
        Sign = 200
        Temp_read = ~Temp_read + 1 
     Else
        Sign = 254
     EndIf   
    TempC  = (Temp_read & $0FF0) >> 4    
    
    Return




 
'=======================================================================
'      
'=======================================================================

' Initialize DS1820 and check for presence
init1820:

        Low DQ                  ' Set the data pin low to init
        DelayUS 500             ' Wait > 480us
        Input DQ              ' Release data pin (set to input for high)
        DelayUS 100  ' Wait > 60us          
        If DQ = 1 Then
        DelayMS 500
        Return   ' Try again
        EndIf
        DelayUS 400             ' Wait for end of presence pulse
Return


' Write "command" byte to the DS1820
write1820:
For i = 1 To 8          ' 8 bits to a byte
If command.0 = 0 Then
GoSub write0    ' Write a 0 bit
Else
GoSub write1    ' Write a 1 bit
EndIf
command = command >> 1  ' Shift to next bit
Next i
Return

' Write a 0 bit to the DS1820
write0:
        Low DQ
        DelayUS 60              ' Low for > 60us for 0
        Input DQ              ' Release data pin (set to input for high)
        Return

' Write a 1 bit to the DS1820
write1:
        Low DQ                  ' Low for < 15us for 1
@       nop                     ' Delay 1us at 4MHz
        Input DQ              ' Release data pin (set to input for high)
        DelayUS 60              ' Use up rest of time slot
        Return


' Read temperature from the DS1820
read1820:
For i = 1 To 16         ' 16 bits to a word
Temp_read = Temp_read >> 1        ' Shift down bits
GoSub readbit   ' Get the bit to the top of temp
Next i
Return

' Read a bit from the DS1820
readbit:
        Temp_read.15 = 1             ' Preset read bit to 1
        Low DQ                  ' Start the time slot
@       nop                     
        Input DQ              ' Release data pin (set to input for high)
        If DQ = 0 Then
        Temp_read.15 = 0     ' Set bit to 0
        EndIf     
        DelayUS 60              ' Wait out rest of time slot
Return
        
        
End

